> For the complete documentation index, see [llms.txt](https://docs.ecwid.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ecwid.com/api-reference/rest-api/checkout-extra-fields.md).

# Checkout extra fields

**Checkout extra fields** allow you to add highly customizable input fields, selectors, and tips/charges to the checkout.&#x20;

With checkout extra fields, you can:

* Collect additional customer data at the checkout and save it to the order details, for example, delivery comments.
* Set up a tips collection in your store.
* Collect additional hidden surcharges based on certain conditions, for example, specific shipping methods.
* Set up a referral or loyalty tracking.
* And many more!

Choose one of three ways of adding extra fields to the checkout:

* Use a [**no-code solution**](https://my.ecwid.com/#extrafield-settings) built into the Ecwid admin.\
  The functionality is limited to input fields, selectors, and a non-configurable datepicker.
* Set up a custom JavaScript file that dynamically adds checkout extra fields on the storefront. This way, you are not limited in available functionality, and can set up extra fields flexibly for each order depending on custom conditions. [Add checkout extra fields with JavaScript](https://docs.ecwid.com/api-reference/rest-api/checkout-extra-fields/add-checkout-extra-fields-with-javascript.md)
* Create and manage checkout extra fields with the REST API. This way, you also have access to all functionality and do not depend on the availability of your JavaScript file. However, these fields will always be the same for all orders in your store. [Manage checkout extra fields with REST API](https://docs.ecwid.com/api-reference/rest-api/checkout-extra-fields/manage-checkout-extra-fields-with-rest-api.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ecwid.com/api-reference/rest-api/checkout-extra-fields.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
